#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#define SIN_MEMORIA 0
#define TODO_BIEN 1
#define CLAVE_DUPLICADA 2



///////////////////////////////////////////////////////////////////////
/////////////////////////ESTRUCTURAS DE DATOS//////////////////////////
///////////////////////////////////////////////////////////////////////



typedef struct				{
   							int clave;
   							char ayn[31];
               			}t_info;

typedef struct s_nodo	{
   							t_info info;
   							struct s_nodo 	*izq,
   							               *der;
  								}t_nodo;

typedef t_nodo *t_arbol;



///////////////////////////////////////////////////////////////////////
////////////////////////DECLARACION DE FUNCIONES///////////////////////
///////////////////////////////////////////////////////////////////////



int comparar (const t_info *, const t_info *);
void crearArbol (t_arbol *);
int cargarenArbol (t_arbol *, const t_info *);
void mostrar (const t_info *);
void mostrarHojas (const t_arbol *);
void mostrarNoHojas (const t_arbol *);
int cuentaHojas (const t_arbol *);
int cuentaNoHojas (const t_arbol *);
int alturaArbol (const t_arbol *);
void mostrarNivel (const t_arbol *, int);
void promedioNodos (const t_arbol *, int *, int *);
float promedio (const t_arbol *);
void preOrden (const t_arbol *);
void inOrden (const t_arbol *);
void posOrden (const t_arbol *);
void eliminarHojas (t_arbol *);
void eliminarArbol (t_arbol *);
void podarRama (t_arbol *, int);

///////////////////////////////////////////////////////////////////////
/////////////////////////////////MAIN//////////////////////////////////
///////////////////////////////////////////////////////////////////////



void main ()
{
t_arbol raiz;
t_info dato;
int nivel, opcion, carga;
float prom=0.;

crearArbol (&raiz);

do
	{
	clrscr();

   printf ("\n\t\t***MEN%c DE OPCIONES***\n\n", 233);
   printf ("\t1.- Cargar Nodo\n");
   printf ("\t2.- Mostrar Hojas\n");
   printf ("\t3.- Mostrar No Hojas\n");
   printf ("\t4.- Contar Hojas\n");
   printf ("\t5.- Contar No Hojas\n");
   printf ("\t6.- Altura del %crbol\n", 181);
   printf ("\t7.- Mostrar Nivel\n");
   printf ("\t8.- Calcular promedio de los nodos con clave par\n");
   printf ("\t9.- Mostrar en PreOrden\n");
   printf ("\t10.- Mostrar en InOrden\n");
   printf ("\t11.- Mostrar en PosOrden\n");
   printf ("\t12.- Eliminar Hojas\n");
   printf ("\t13.- Eliminar %crbol\n", 181);
   printf ("\t14.- Podar Rama con Nivel\n");
   printf ("\t0.- Fin\n");
   printf ("\t\n\nIngrese su opci%cn: ", 162);
   scanf ("%d", &opcion);
   fflush(stdin);

   switch (opcion)
   	{
      case	0:	printf ("\nFin del programa, pulse cualquier tecla para salir");
      			break;

      case	1:	printf ("\nClave: ");
					scanf ("%d", &dato.clave);
               printf ("\nApellido y Nombre: ");
   				fflush(stdin);
   				gets (dato.ayn);
               carga=cargarenArbol (&raiz, &dato);
               switch (carga)
               	{
                  case	0:	printf ("\nSin memoria");
               				break;
                  case	1:	printf ("\nSe pudo cargar en el %crbol", 160);
                  			break;
                  case	2:	printf ("\nClave duplicada");
                  			break;
                  default:	break;
                  }
   				break;

      case 	2:	mostrarHojas (&raiz);
      			break;

      case	3:	mostrarNoHojas (&raiz);
               break;

      case	4:	printf ("\nEl %crbol tiene %d hojas", 160, cuentaHojas (&raiz));
               break;

      case	5:	printf ("\nEl %crbol tiene %d no hojas", 160, cuentaNoHojas (&raiz));
      			break;

      case	6:	printf ("\nEl %crbol tiene altura %d", 160, alturaArbol (&raiz));
               break;

      case	7:	printf ("\nIngrese nivel que desea mostrar: ");
      			scanf ("%d", &nivel);
               mostrarNivel (&raiz, nivel);
               break;

      case	8: prom=promedio (&raiz);
      			printf (prom?"\nEl promedio de los nodos con clave par es: %.2f":"\nNo se encontraron nodos pares", prom);
               break;

      case	9: printf ("\nEn PreOrden: \n");
					preOrden (&raiz);
               break;

      case 10:	printf ("\nEn InOrden: \n");
      			inOrden (&raiz);
               break;

      case 11:	printf ("\nEn posOrden: \n");
      			posOrden (&raiz);
               break;

      case 12:	eliminarHojas (&raiz);
      			printf ("\nSe eliminaron las hojas");
      			break;

      case 13:	eliminarArbol (&raiz);
	     			printf ("\nSe elimino el arbol");
               break;

      case 14: printf ("\nIngrese nivel a partir del que se va a podar: ");
	     			scanf ("%d", &nivel);
               podarRama (&raiz, nivel);
               printf ("\nEl arbol ha sido podado con exito");
               break;

      default:	printf ("\nOpci%cn inexistente, ingrese nuevamente", 162);
      			break;
      }
   getch();

   }while (opcion);
   
}



///////////////////////////////////////////////////////////////////////
///////////////////////DEFINICION DE FUNCIONES/////////////////////////
///////////////////////////////////////////////////////////////////////



int comparar (const t_info *d, const t_info *dnodo)
{
return d->clave-dnodo->clave;
}

///////////////////////////////////////////////////////////////////////

void crearArbol (t_arbol *p)
{
*p=NULL;
}

///////////////////////////////////////////////////////////////////////

int cargarenArbol (t_arbol *p, const t_info *d)
{
int cmp;
if (*p)
	{
   cmp=comparar (d, &(*p)->info);
   if (!cmp)
   	return CLAVE_DUPLICADA;
   if (cmp<0)
   	return cargarenArbol (&(*p)->izq, d);
   else
   	return cargarenArbol (&(*p)->der, d);
   }
*p=(t_nodo *)malloc(sizeof (t_nodo));
if (!*p)
	return SIN_MEMORIA;
(*p)->info=*d;
(*p)->izq=(*p)->der=NULL;
return TODO_BIEN;
}

///////////////////////////////////////////////////////////////////////

void mostrar (const t_info *d)
{
printf ("\nClave: %d   -   Apellido y Nombre: %s", d->clave, d->ayn);
}

///////////////////////////////////////////////////////////////////////

void mostrarHojas (const t_arbol *p)
{
if (*p)
	{
   if (!(*p)->der&&!(*p)->izq)
   	mostrar (&(*p)->info);
   else
   	{
      mostrarHojas (&(*p)->izq);
      mostrarHojas (&(*p)->der);
      }
   }
}

///////////////////////////////////////////////////////////////////////

void mostrarNoHojas (const t_arbol *p)
{
if (*p)
	{
	if ((*p)->izq||(*p)->der)
   	{
      mostrar (&(*p)->info);
      mostrarNoHojas (&(*p)->izq);
      mostrarNoHojas (&(*p)->der);
      }
   }
}

///////////////////////////////////////////////////////////////////////

int cuentaHojas (const t_arbol *p)
{
if (*p)
	{
   if (!(*p)->izq&&!(*p)->der)
   	return 1;
   else
   	return cuentaHojas (&(*p)->izq)+ cuentaHojas (&(*p)->der);
   }
else
	return 0;
}

///////////////////////////////////////////////////////////////////////

int cuentaNoHojas (const t_arbol *p)
{
if (*p)
   if ((*p)->izq||(*p)->der)
   	return 1+ cuentaNoHojas (&(*p)->izq)+ cuentaNoHojas (&(*p)->der);
return 0;
}

///////////////////////////////////////////////////////////////////////

int alturaArbol (const t_arbol *p)
{
int hd, hi;
if (*p)
	{
   hi=alturaArbol (&(*p)->izq);
   hd=alturaArbol (&(*p)->der);
   return (hi>hd)?hi+1:hd+1;
   }
return 0;
}

///////////////////////////////////////////////////////////////////////

void mostrarNivel (const t_arbol *p, int niv)
{
if (*p)
	{
   if (niv==1)
   	mostrar (&(*p)->info);
   else
   	{
      mostrarNivel (&(*p)->izq, niv-1);
      mostrarNivel (&(*p)->der, niv-1);
      }
   }
}

///////////////////////////////////////////////////////////////////////

void promedioNodos (const t_arbol *p, int *cont, int *sum)
{
if (*p)
	{
   if ((*p)->info.clave%2==0)
   	{
      *cont+=1;
      *sum+=(*p)->info.clave;
      }
   promedioNodos (&(*p)->izq, cont, sum);
	promedioNodos (&(*p)->der, cont, sum);
   }
}

///////////////////////////////////////////////////////////////////////

float promedio (const t_arbol *p)
{
int cont=0, sum=0;
promedioNodos (p, &cont, &sum);
return cont?sum/(float)cont:cont;
}

///////////////////////////////////////////////////////////////////////

void preOrden (const t_arbol *p)
{
if (*p)
	{
   mostrar (&(*p)->info);
   preOrden (&(*p)->izq);
   preOrden (&(*p)->der);
   }
}

///////////////////////////////////////////////////////////////////////

void inOrden (const t_arbol *p)
{
if (*p)
	{
   inOrden (&(*p)->izq);
   mostrar (&(*p)->info);
   inOrden (&(*p)->der);
	}
}

///////////////////////////////////////////////////////////////////////

void posOrden (const t_arbol *p)
{
if (*p)
	{
   posOrden (&(*p)->izq);
   posOrden (&(*p)->der);
   mostrar (&(*p)->info);
   }
}

///////////////////////////////////////////////////////////////////////

void eliminarHojas (t_arbol *p)
{
if (*p)
	{
   if (!(*p)->izq&&!(*p)->der)
   	{
      free (*p);
      *p=NULL;
      }
   else
   	{
      eliminarHojas (&(*p)->izq);
      eliminarHojas (&(*p)->der);
      }
   }
}

///////////////////////////////////////////////////////////////////////

void eliminarArbol (t_arbol *p)
	{
   if (*p)
   	{
      eliminarArbol (&(*p)->izq);
      eliminarArbol (&(*p)->der);
      if (!(*p)->izq&&!(*p)->der)
      	{
         free (*p);
         *p=NULL;
         }
      }
   }

////////////////////////////////////////////////////////////////////////////

void podarRama (t_arbol *p, int c)
	{
   if (*p)
   	{
      podarRama (&(*p)->izq, c-1);
      podarRama (&(*p)->der, c-1);
      if (!(*p)->izq&&!(*p)->der&&c<=0)
      	{
         free (*p);
         *p=NULL;
     		}
	   }
	}

